/*   This file is part of Xsltop.
*
*    Xsltop is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation.
*
*    Xsltop is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY.  See the
*    GNU General Public License for more details.
*
*    See <http://www.gnu.org/licenses/>.
*/
package xsltop.gui;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.List;

import javax.swing.JTextArea;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

/**
 * XPathConsole is a JTextArea
 * @author philippe voncken
 *
 */
public class XPathConsole extends JTextArea 
implements DocumentListener, KeyListener {
	/** . */
	private static final long serialVersionUID = -4176147480631540386L;
	/** To delegate the technical mecanism to manager. */
	private GuiManager manager;
	@SuppressWarnings("unused")
	private XPathConsole() {		
	}
	/**
	 * 
	 * @param label
	 */
	public XPathConsole(GuiManager manager) {
		this.getDocument().addDocumentListener(this);
		this.addKeyListener(this);
		this.manager = manager;		
	}
	public void changedUpdate(DocumentEvent e) {
		//System.out.println("change update xpath");		
	}	
	public void insertUpdate(DocumentEvent e) {
		//System.out.println("insert update xpath");		
	}	
	public void removeUpdate(DocumentEvent e) {
		//System.out.println("remove update xpath");
	}
	public void keyPressed(KeyEvent e) {
		//System.out.println("keyPressed xpath " + e.getKeyCode());
/*		if (10 == e.getKeyCode()) { // si Enter
			
			String lastline = getLastLine();
			List list = performXPath(interpretLine(lastline));
			this.setText(
					this.getText() + "\n"
					+ "total find: " + list.size() + "\n"
					+ listToString(list)
					);
		}*/
	}
	public List<String> performXPath(String xpath) {
		List<String> list;
		list = manager.performXPath(xpath);
		return list;
	}
	public String interpretLine(String lastline) {
		return lastline;
	}
	public String listToString(List<String> list) {
		StringBuilder string = new StringBuilder();
		for (String s: list) {
			string.append(s);
			string.append("\n");
		}
		return string.toString();
	}
	public void keyReleased(KeyEvent e) {
		//System.out.println("keyReleased xpath " + e.getKeyCode());
	}
	public void keyTyped(KeyEvent e) {
		//System.out.println("keyTyped xpath " + e.getKeyCode());
	}
}
